/************************************************************************
	charlieplex.c

    MicroSimon (MB Electronics Simon Clone)
    Copyright (C) 2011 Simon Inns

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

	Email: simon.inns@gmail.com

************************************************************************/

#ifndef CHARLIEPLEX_C
#define CHARLIEPLEX_C

// Global includes
#include <htc.h>

// Local includes
#include "hardware.h"
#include "charlieplex.h"

// Charliplexed LED control
void led(unsigned char ledNumber)
{
	// Turn everything off to prevent 'flashes' during update
	CPLEDT1 = 0;
	CPLEDT2 = 0;
	CPLEDT0 = 0;
	
	CPLED1 = 0;
	CPLED2 = 0;
	CPLED0 = 0;
	
	// 0 = all off
	switch (ledNumber)
	{
		case OFF:	CPLEDT1 = 0;
					CPLEDT2 = 0;
					CPLEDT0 = 0;
					
					CPLED1 = 0;
					CPLED2 = 0;
					CPLED0 = 0;
					break;
		
		case BLUE:	CPLEDT1 = 0; 	// 0V
					CPLEDT2 = 0; 	// 3V
					CPLEDT0 = 1; 	// Not used
					
					CPLED1 = 0; 	// 0V
					CPLED2 = 1; 	// 3V
					CPLED0 = 0; 	// Not used
					break;
					
		case RED:	CPLEDT1 = 1; 	// Not used
					CPLEDT2 = 0; 	// 0V
					CPLEDT0 = 0; 	// 3V
					
					CPLED1 = 0; 	// Not used
					CPLED2 = 0; 	// 0V
					CPLED0 = 1; 	// 3V
					break;
					
		case GREEN:	CPLEDT1 = 0;	// 3V
					CPLEDT2 = 0;	// 0V
					CPLEDT0 = 1; 	// Not used
					
					CPLED1 = 1;  	// 3V
					CPLED2 = 0;   	// 0V
					CPLED0 = 0;	 	// Not used
					break;
					
		case WHITE:	CPLEDT1 = 1;	// Not used
					CPLEDT2 = 0;	// 3V
					CPLEDT0 = 0;	// 0V
					
					CPLED1 = 0;		// Not used
					CPLED2 = 1;		// 3V
					CPLED0 = 0;		// 0V
					break;
	}	
}

#endif