/************************************************************************
	hardware.h

    MicroSimon (MB Electronics Simon Clone)
    Copyright (C) 2011 Simon Inns

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

	Email: simon.inns@gmail.com

************************************************************************/

#ifndef _HARDWARE_H_
#define _HARDWARE_H_

// Define oscillator frequency (4 Mhz)
#define _XTAL_FREQ 4000000

// Required debounce polls
#define DEBOUNCE_AMOUNT	20

// Hardware mapping definitions for the 6 GPIO pins
#define BUTTONS GPIO0
#define CPLED0	GPIO1
#define CPLED1	GPIO2
#define MCLR	GPIO3
#define CPLED2	GPIO4
#define SPEAKER	GPIO5

// Mappings for the TRIS state for LED control
#define CPLEDT0	TRISIO1
#define CPLEDT1	TRISIO2
#define CPLEDT2	TRISIO4

// Mappings for the 4 LED colours
#define BLUE	1
#define RED		2
#define GREEN	3
#define WHITE	4

// Mapping for the 4 colour sounds (see
// http://www.waitingforfriday.com/index.php/Reverse_engineering_an_MB_Electronic_Simon_game )
#define S_BLUE	208
#define S_RED	311
#define S_GREEN	415
#define S_WHITE	248

// Fail sound
#define S_FAIL	42

// Useful defines
#define OFF		0
#define ON		1
#define FALSE	0
#define TRUE	1

// Selected skill level
unsigned char skillLevel = 0;

// Random number store
unsigned char randomNumber = 1;

#endif