/************************************************************************
	simon.h

    MicroSimon (MB Electronics Simon Clone)
    Copyright (C) 2011 Simon Inns

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

	Email: simon.inns@gmail.com

************************************************************************/

#ifndef _SIMON_H_
#define _SIMON_H_

// State machine state definitions
#define GS_PLAYING_SEQUENCE_COLOUR		1
#define GS_PLAYING_SEQUENCE_HOLD_COLOUR	2
#define GS_PLAYING_SEQUENCE_PAUSE		3
#define GS_WAITING_FOR_COLOUR			4
#define GS_WAITING_FOR_RELEASE			5
#define GS_GAME_OVER_WIN				6
#define GS_GAME_OVER_LOSE				7
#define GS_PAUSE_BEFORE_REPLAY			8

// Globals for game state machine
unsigned char gameCurrentState = GS_PLAYING_SEQUENCE_COLOUR;
unsigned char gameSequence[32];
unsigned char sequenceNumber = 0;
unsigned char coloursInSequence = 0;
unsigned int gameTimer = 0;

// Function prototypes
unsigned char pollGameStateMachine(void);

#endif